#pragma once

enum SocketFrom_e
{
    SF_GameGate,
};

enum InnerMesssage_e
{
    IM_ClientSocketDisconnect  = 100,
    IM_PlayerOffline,
    IM_ExecGM,
    IM_DBSConnDisconnect,
    IM_BSConnDisconnect,
    IM_LoadConfig,
    IM_HttpResponse,
    IM_GGListenerError
};

//网络处理对象
enum NetHandler_e
{
    HID_Player,
    HID_PlayerMgr,
    HID_Room,
    HID_RoomMgr,
    HID_GGListener,
};

enum PlayerState_e
{
    PS_None
};

enum VirtualItemId_e
{
    VID_Item_Gold = 50001,
    VID_Item_Exp = 50002,
    VID_Soul_Stone = 50018,
    VID_Pickaxe = 50019
};

enum SyncData_e
{
    SYNC_Data_Exp = 0,
};

enum DoorState_e
{
    DoorStateClose = 0,
    DoorStateOpen = 1
};

enum GasMode_e
{
    GasInactive = 0,
    GasWaiting = 1,
    GasMoving = 2,
};

enum ActionType_e
{
    AT_None = 0,
    AT_Reload = 1,
    AT_UseItem = 2,
    AT_Relive = 3,
    AT_Rescue = 4
};

enum RoomType_e
{
   RT_NewBrid = 0,
   RT_MidBrid = 1,
   RT_OldBrid1 = 2,
   RT_OldBrid2 = 3,
   RT_OldBrid3 = 4,
   RT_Max
};

enum InventorySlot_e
{
    IS_9MM  = 0,
    IS_556MM  = 1,
    IS_762MM  = 2,
    IS_12GAUGE  = 3,
    IS_RPG  = 4,
    IS_FRAG  = 5,
    IS_SMOKE  = 6,
    IS_HEALTHKIT  = 7, //医疗包
    IS_PAIN_KILLER  = 8, //止痛药

    IS_1XSCOPE  = 12,
    IS_2XSCOPE  = 13,
    IS_4XSCOPE  = 14,
    IS_8XSCOPE  = 15,
    IS_15XSCOPE = 16,

    IS_END
};

enum BuffTriggerType_e
{
    kBTT_UseSkill = 1, //技能释放时触发
    kBTT_Kill = 2, //击杀敌方后触发
    kBTT_SkillHit = 3, //技能命中触发
    kBTT_OtherBuff = 4,//其他buff触发
    kBTT_UseItem = 6   //使用道具触发
};

enum BuffTargetType_e
{
    kBuffTargetSelf = 1, //自己
    kBuffTargetFriendly = 2, //友军
    kBuffTargetEnemy = 3, //敌军
};

enum BuffEffectType_e
{
    kBET_Begin = 0,
    kBET_ChgAttr = 1, //改变属性
    kBET_TurnOver = 2, //翻滚
    kBET_Car = 3, //骑乘
    kBET_Invincible = 4, //无敌
    kBET_Camouflage = 5, //伪装
    kBET_AdPlaying = 6, //看广告中
    kBET_LordMode = 7, //上帝模式
    kBET_NewProtect = 8, //新手保护血量低于50%
    kBET_BePull = 9, //拉人(被拉方)
    kBET_JumpTo = 10, //跳跃
    kBET_OnceChgAttr = 11, //一次性buff
    kBET_Pull = 12, //拉人(主动方)
    kBET_Terminator = 13, //终结者模式
    kBET_PlayShotAni = 14, //播放射击动画
    kBET_Vertigo = 15, //眩晕
    kBET_DecHp = 16, //扣血
    kBET_PullDone = 17, //拖拽到目的地
    kBET_DelayAddBuff = 18, //延迟加buff
    kBET_CliEffect1 = 19, //僵尸被动光环减速（客户端表现用）
    kBET_CliEffect2 = 20, //僵尸被动光环毒物（客户端表现用）
    kBET_CliEffect3 = 21, //僵尸被动光环地震(客户端表现用)
    kBET_CliEffect4 = 22, //被拖拽(客户端表现用)    
    kBET_End
};

enum SkillFunc_e
{
    kSkill_FuncNone = 0,
    kSkill_TurnOver = 1,
    kSkill_JumpTo = 2,
    kSkill_Shot = 3,
    kSkill_Pull = 4,
    kSkill_FuncEnd
};

enum HumanAttrType_e
{
    kHAT_Begin = 0,
    kHAT_Hp = 1,
    kHAT_HPRecover = 2,
    kHAT_Atk = 3,
    kHAT_Def = 4,
    kHAT_Speed = 5,
    kHAT_ShotRange = 6,
    kHAT_ShotSpeed = 7,
    kHAT_ReloadSpeed = 8,
    kHAT_FireRate = 9,
    kHAT_Volume = 10,
    kHAT_MaxHp = 11,
    kHAT_BulletAngle = 20,
    kHAT_End
};

enum SkillTarget_e
{
   kST_All = 0,

   kST_Self = 1,
   kST_FriendlyIncludeSelf = 2,
   kST_FriendlyExcludeSelf = 3,

   kST_EnemySingle = 6,
   kST_EnemyGroup = 7,
   kST_EnemyAndObject = 8,
   kST_EnemyAndSelf = 9,
   kST_SingleEnemyAndSelf = 10
};

enum VirtualWeapon_e
{
    VW_SafeArea = 9000000,
    VW_Spectate = 9000001,
    VW_SelfDetonate = 9000002,
    VW_Mine = 9000003,
    VW_Tank = 9000004,
};

enum VirtualPlayer_e
{
    VP_SafeArea = 9000000,
    VP_Spectate = 9000001,
    VP_SelfDetonate = 9000002,
    VP_Mine = 9000003,
};

#if 0
enum EquipAttr_e
{
    EA_View = 1, //客户端用
    EA_ShotRange = 2,
    EA_Volume = 3,
    EA_AutoAngle = 4, //客户端用
    EA_BulletAngle = 5,
    EA_Atk = 6,
    EA_Def = 7,
    EA_Speed = 8,
    EA_End
};
#endif

enum EquipType_e
{
    EQUIP_TYPE_WEAPON = 1,
    EQUIP_TYPE_BULLET = 2,
    EQUIP_TYPE_OLDSKIN = 8,
    EQUIP_TYPE_CAR = 9,
    EQUIP_TYPE_SKIN = 10,
    EQUIP_TYPE_CAMOUFLAGE = 11,
    EQUIP_TYPE_End
};

enum EntityType_e
{
   ET_None = 0,
   ET_Player = 1,
   ET_Obstacle = 2,
   ET_Building = 3,
   //ET_LootSpawner = 4,
   ET_Loot = 5,
   //ET_DeadBody = 6,
   //ET_Decal = 7,
   //ET_Projectile = 8,
   //ET_Smoke = 9,
   //ET_Hero = 10,

   ET_Bullet = 20,

   //ET_Android = 30,
   ET_Unuse = 30,
   ET_MAX
};

enum EntitySubType_e
{
   EST_None = 0,
   EST_Player = 1,
   EST_Android = 2,
   EST_PermanentObstacle = 3,
   EST_RoomObstacle = 4
};

enum PropertyType_e
{
    kPropHp = 1,
    kPropMaxHp = 2,
    kPropSkillLeftTime = 4,
    kPropSkillCd = 5,
    kPropTankBulletNum = 6,
    kPropTankOil = 7,
    kPropBulletNum = 8,
    kPropItem = 9,
    kPropWeaponAmmo = 10,

    kPropZombieId = 23,
};

enum MapObjectType_e
{
    kMOT_Object = 1,
    kMOT_SpawnPoint = 2
};

enum SkinSlot_e
{
    kSkinSlot_CLOTH = 1,
    kSkinSlot_HAT = 2,
};

enum ObjectFlags_e
{
    kOfWriteCache = 0,
    kOfReadCache = 1,
};

enum ObjectSyncFlags_e
{
    kOsfIsDead = 0,
};

enum RoomMode_e
{
    kChiJiMode = 0,
    kZombieMode = 1,
    kRoomModeEnd
};

enum RaceType_e
{
    kHumanRace = 1,
    kZombieRace = 2
};

enum AIMode_e
{
    kChiJiAiMode = 0,
    kHumanAiMode = 1,
    kZombieAiMode = 2
};

enum ColliderTag_e
{
    kHalfWallTag = 1
};

const char* const PROJ_NAME_FMT = "game%d_gameserver";
const char* const PROJ_ROOT_FMT = "/data/logs/%s";

const float TEN_W = 10000 * 10;

const int SYS_RESET_TIME = 2*60; //每日两点重置

const int DEF_WEAPON_ID = 12103;

const int SERVER_FRAME_RATE = 20;
const int SYNC_FRAME_RATE = 10;
const float FRAME_RATE_MS = 1000.0f / SERVER_FRAME_RATE;

const int MAX_WEAPON_NUM = 5;
const int MAX_SKIN_LV = 9;

const int GUN_SLOT1 = 1;
const int GUN_SLOT2 = 2;

const int FRAG_SLOT = 3;
const int SMOKE_SLOT = 4;

const int DOOR_THING_ID = 61701;

const int FIGHTING_MODE_BULLET_NUM = 10000 * 10000;

const int MAX_NODE_ID = 8;
const int MAX_INSTANCE_ID = 500;

const int WALK_ZONE_WIDTH = 100;

const int MAX_TEAM_NUM = 4;

const int MAX_SYS_HTTP_NUM = 2;
const int MAX_USER_HTTP_NUM = 8;
const int MAX_ALL_HTTP_NUM = MAX_SYS_HTTP_NUM + MAX_USER_HTTP_NUM;

const int DEFAULT_BORN_POINT_X = 3000;
const int DEFAULT_BORN_POINT_Y = 3000;

const int ADPLAY_BUFFID = 1006;

const int FIXED_OBJECT_MAXID = 1024;

const int MAX_ROOM_IDX = 2018;

const int VIEW_RANGE = 512;

const int MAX_AI_LEVEL = 8;

const int HUMAN_RACE_META_START_ID = 5001;
const int ZOMBIE_RACE_META_START_ID = 6001;

const int TERMINATOR_BUFF_ID = 1033;

const int TURN_OVER_SKILL_ID = 41001;

